#!/usr/bin/python
# -*- coding: utf-8 -*-

import Gloska
import akcenty

gloski_file = 'data/rules.txt'
rules = map(lambda line: (line.strip().split('->')[0].strip().decode('utf-8'), line.split('->')[1].decode('utf-8').strip().split(',')), open(gloski_file))
rules = filter(lambda (a, b): not a.startswith(u'#'), rules)
maxlen = max(map(lambda (g,f): len(g.strip("^$")), rules))
rules = dict(rules)

def main(word):
	gloski, i = [], 0
	
	while i < len(word):
		for j in range(maxlen):
			take = maxlen - j
			part = word[i:i+take]
			if i+take == len(word):
				if part+'$' in rules:
					key = part+'$'
					gloski.extend(map(lambda gl: Gloska.Gloska(gl), rules[key]))
					break
			if i == 0:
				if '^'+part in rules:
					key = '^'+part
					gloski.extend(map(lambda gl: Gloska.Gloska(gl), rules[key]))
					break
			if part in rules:
				key = part
				gloski.extend(map(lambda gl: Gloska.Gloska(gl), rules[key]))
				break
		i += take
		gloski = reduce(lambda a, b: a[:-1] + [b] if (a[-2].name in ['ci', 'si', 'ni', 'zi', 'dzi'] and a[-1].name == u'i' and
													b.isVowel())
														else a + [b], gloski[2:], gloski[:2])
	return gloski

def backward(phones):
	
	''' przechodzi przez głoski i uskutecznia upodobnienie wsteczne '''
	
	for i in range(len(phones)-1, 0, -1):
		if not (phones[i].isVowel() or phones[i-1].isVowel() or 
					phones[i].stopien_zblizenia in [u'półsamogłoskowa',u'drżąca', u'nosowa', u'boczna']) and (
									phones[i].dzwieczna != phones[i-1].dzwieczna):
			phones[i-1].zmien_dzwiecznosc()
			
	return phones


def forward(phones):
	
	''' przechodzi przez głoski i uskutecznia upodobnienie postępowe 
		przy okazji zmienia i niesylabotwórcze na j '''
	
	for i in range(1, len(phones)):
		if (phones[i].name in [u'w', u'rz', u'r'] and phones[i].dzwieczna  and not phones[i-1].dzwieczna
			and phones[i-1].stopien_zblizenia not in [u'nosowa', u'boczna', u'półsamogłoskowa'] 
				and not phones[i-1].isVowel()):
			phones[i].ubezdzwiecznij()
		
		if phones[i].name == u'i' and i+1 < len(phones) and phones[i+1].isVowel():
			phones[i]=Gloska.Gloska(u'j')
				
	return phones

def unosowienie(phones):
	change = []
	for i in range(0, len(phones)-2):
		if phones[i].name in [u'o', u'e'] and phones[i+1].name in [u'n'] and phones[i+2].stopien_zblizenia == u'szczelinowa':
			change.append(i)
	for i in range(len(change)):
		[phones[change[i]-i].nazalizuj()]
		phones = phones[:change[i]-i+1] + phones[change[i]+2-i:]
		
	return phones

def graphem2phonem(graphem):
	phonem = main(graphem)
	try: phonem[-1].ubezdzwiecznij()
	except: pass
	phonem = forward(phonem) if not graphem.endswith(u'że') else (forward(phonem[:-2]) + phonem[-2:]) if len(phonem[:-2])>2 else phonem
	phonem = backward(phonem)
	phonem = unosowienie(phonem)
	if phonem[-1].name == u'en': phonem[-1] = Gloska.Gloska(u'e')
	return phonem

class Slowo:
	
	def __init__(self, word):
		self.orginal = word
		self.gloski = graphem2phonem(word)
		self.akcent_sylaba = akcenty.akcent(word)
		self.akcent_gloska = self._akcent()
		if self.akcent_gloska is not None:
			self.gloski[self.akcent_gloska].zaakcentuj()
		self.bytes = ""
		
	def get_bytes(self):
		for G in self:
			self.bytes += (G.get_bytes())
		
		return self.bytes
	
	def _akcent(self):
		a, place = 0, 0
		for i in range(len(self.gloski)-1, -1, -1):
			if self.gloski[i].isVowel():
				a += 1
				place = i
			if a == self.akcent_sylaba:
				return place
		
		if a > 1:
			return place
		
		return None
		
	def __iter__(self):
		return self.gloski.__iter__()
		
	def __getitem__(self, i):
		return self.gloski[i]
	
	def __setitem__(self, i, item):
		self.gloski[i] = item
		
	def __repr__(self):
		return '<%s>' % self.gloski
		
	def __str__(self):
		return '-'.join(map(lambda G: G.name.upper() if G.akcent else G.name, self.gloski))	
