#!/usr/bin/python
# -*- coding: utf-8 -*-

import re

# wczytujemy z plkiku 'akcenty.txt' słowa w których akcent nie pada na drugą sylabe od końca
akcenty = set([line.strip().lower().decode('utf-8')
               for line in open('data/akcenty.txt')])

def generate_exception_words(morfologik='morfologik.txt'):
	
	""" Funkcja bierze plik z morfologikiem i drukuje słowa, w których akcent nie jest paroksytoniczny """
	
	for line in open(morfologik):
		try: (word, base, tag) = line.strip().split()
		except: continue
	
		# pmijamy imiona i nazwiska, zostawiając parę nazw własnych
		if base not in ['Ameryka', 'Afryka', 'Antarktyka', 'Arktyka', 
				'Dominika', 'Korsyka', 'Martynika', 'Mezoameryka', 
				'Palearktyka', 'Panameryka', 'Scholastyka', 'Tanganika'] and (base.lower() != base):
			continue
		
		for sufix in ['yka', 'ika']:
			if base.endswith(sufix) and tag.split(':')[0] == 'subst':
				print word
					
#generate_exception_words('morfologik.txt')

def akcent(word):
	
	''' Funkcja bierze słowo i zwraca, na którą sylabę od końca pada w nim akcent 
		(Oczywiście siłą rzeczy czasem będzie się mylić) '''
	
	if re.search(u'(ła|ło|ły|li)by(śmy|ście)$', word):
		return 4
	
	if (re.search(u'(ła|ło|ły|li|[uaeyięą]ł)by(m|ś)?$', word) or re.search(u'(ły|li)(ście|śmy)$', word)):
		return 3
	
	if re.search(u'[^aeuoióęą]że$', word):
		return 3
	
	if word in akcenty:
		return 3
	
	return 2
